'use strict';

const moment = require('moment');

module.exports = app => {
    const { STRING, INTEGER, DATE, DECIMAL, TEXT, ENUM } = app.Sequelize;

    const CourseTeacher = app.classModel.define('course_teacher_v1', {
        id: {
            type: INTEGER,
            primaryKey: true,
            autoIncrement: true
        },
        institution_id: INTEGER,
        name: STRING,
        avatar: STRING,
        teacher_experience: INTEGER,
        nationality: STRING,
        educational_background: STRING,
        certificate: STRING,
        honor: STRING,
        lesson: STRING,
        work_experience: STRING,
        point: STRING,
        description: TEXT,
        status: ENUM('offline', 'online'),
        is_deleted: INTEGER,
        created_time: {
            type: DATE,
            allowNull: true,
            get() {
                const date = this.getDataValue('created_time');
                return date ? moment(date).format('YYYY-MM-DD HH:mm:ss') : undefined;
            },
        }
    }, {
            timestamps: false,
            tableName: 'course_teacher_v1',
        });

    CourseTeacher.one = async (data) => {
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        return await CourseTeacher.findOne({
            attributes: attributes,
            where: where,
        });
    }

    CourseTeacher.all = async (data) => {
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        const order = data.order ? data.order : [];
        return await CourseTeacher.findAll({
            attributes: attributes,
            where: where,
            order,
        });
    }

    CourseTeacher.list = async (data = {}) => {
        const limit = data.limit ? Number(data.limit) : 10;
        const page = data.page ? Number(data.page) : 1;
        const order = data.order ? data.order : [];
        const attributes = data.attributes ? data.attributes : {};
        const where = data.where ? data.where : {};
        const condition = {
            offset: (page - 1) * limit,
            limit,
            where: where,
            order: order,
            attributes: attributes,
        };
        const { count, rows } = await CourseTeacher.findAndCountAll(condition);
        return { page, count, rows };
    }

    CourseTeacher.add = async (data) => {
        try {
            //返回promise对象实力 instance 
            const res = await CourseTeacher.create(data);
            //从promise 实例中中获得需要的id号，id 必须是自增长，而且必须主键，否则返回null
            return res.id;
        } catch (error) {
            throw (error);
        }
    }

    CourseTeacher.edit = async (data) => {
        const where = data.where;
        const params = data.params;
        try {
            const res = await CourseTeacher.update(params, { where: where })
            return res;
        } catch (error) {
            throw (error);
        }
    }

    return CourseTeacher;

};